﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Syncfusion.JavaScript.Models;
using System.Collections;
using System.Text.RegularExpressions;
using ScheduleCRUD.Models;

namespace ScheduleCRUD.Controllers
{
    public class HomeController : Controller
    {
        DataClasses1DataContext db = new DataClasses1DataContext();
        public ActionResult Index()
        {
            var DataSource = new DataClasses1DataContext().ScheduleDatas.ToList();
            ViewBag.dataSource = DataSource;
            return View();
        }
        public void DeleteApp(int id, string date)
        {
            ScheduleData appoint = db.ScheduleDatas.Single(A => A.Id == Convert.ToInt32(id)); // here we are filtering the parent recurrence app
            if (!appoint.RecurrenceRule.Contains("EXDATE"))
                appoint.RecurrenceRule = appoint.RecurrenceRule + ";EXDATE=" + date; // here we are updating the recurrence rule
            else
            { // this loop will excute when we delete the another instance of the recurrence appointment
                var recurRule = appoint.RecurrenceRule.Split(';'); // we are splitting the rule here 
                string splitRule = "";
                for (var i = 0; i < recurRule.Count(); i++)
                {
                    if (splitRule != "")
                        splitRule += ";";
                    if (recurRule[i].Contains("EXDATE"))
                    { // here we are updating the EXDATE
                        var recurExdate = recurRule[3].Split('=');
                        var recurAdd = recurExdate[1] + "," + date;
                        recurRule[3] = recurExdate[0] + "=" + recurAdd;
                    }
                    splitRule += recurRule[i]; // here we are forming the recurrence rule with the updated EXDATE
                }
                appoint.RecurrenceRule = splitRule;
            }
            db.SubmitChanges(); // updating the data base
        }

    }

}